# ARST打卡第118周[118/521]

<!--more-->

## Algorithm
lc1137_第N个泰波那契数

### 思路
1. 想到的是直接本地运算，然后打表
2. 打表找规律，然后直接用计算式做

然后发现是要[用矩阵快速幂(看题解答案吧)](https://leetcode-cn.com/problems/n-th-tribonacci-number/solution/di-n-ge-tai-bo-na-qi-shu-by-leetcode-sol-kn16/)


### 代码
```cpp
class Solution {
public:
    int tribonacci(int n) {
        if (n == 0) {
            return 0;
        }
        if (n <= 2) {
            return 1;
        }
        vector<vector<long>> q = {{1, 1, 1}, {1, 0, 0}, {0, 1, 0}};
        vector<vector<long>> res = pow(q, n);
        return res[0][2];
    }

    vector<vector<long>> pow(vector<vector<long>>& a, long n) {
        vector<vector<long>> ret = {{1, 0, 0}, {0, 1, 0}, {0, 0, 1}};
        while (n > 0) {
            if ((n & 1) == 1) {
                ret = multiply(ret, a);
            }
            n >>= 1;
            a = multiply(a, a);
        }
        return ret;
    }

    vector<vector<long>> multiply(vector<vector<long>>& a, vector<vector<long>>& b) {
        vector<vector<long>> c(3, vector<long>(3));
        for (int i = 0; i < 3; i++) {
            for (int j = 0; j < 3; j++) {
                c[i][j] = a[i][0] * b[0][j] + a[i][1] * b[1][j] + a[i][2] * b[2][j];
            }
        }
        return c;
    }
};
```

## Review
[SMB2: what is MsFteWds and Srvsvc files?](https://social.msdn.microsoft.com/Forums/office/en-US/889e7497-3bab-42dc-b4fe-1952890351af/smb2-what-is-msftewds-and-srvsvc-files?forum=os_fileservices)

[Named Pipes](https://docs.microsoft.com/en-us/windows/win32/ipc/named-pipes)

## Tips
[如何在python中隐藏密码](https://mlog.club/article/483735)

[Git分支-变基](https://git-scm.com/book/zh/v2/Git-%E5%88%86%E6%94%AF-%E5%8F%98%E5%9F%BA)

## Share
[python变量是否在类中-普通常规类也可以判断](https://blog.csdn.net/neve_give_up_dan/article/details/119411852?spm=1001.2014.3001.5501)

